/* This file is part of KDE PIM
   Copyright (C) 1999 Don Sanders <sanders@kde.org>

   License: BSD
*/

#ifndef UNDO_H
#define UNDO_H

#include <qptrstack.h>
#include <qstring.h>

class Command
{
public:
  virtual ~Command() {};
  virtual QString name() { return ""; };
  virtual void redo() {}; // egcs requires these methods to have
  virtual void undo() {}; // implementations (Seems like a bug)
};

typedef QPtrStack< Command > StackBase;

class UndoStack : public StackBase
{
public:
  static UndoStack *instance();
  void undo();

protected:
  UndoStack();
  static UndoStack* instance_;
};

class RedoStack : public StackBase
{
public:
  static RedoStack *instance();
  void redo();

protected:
  RedoStack();
  static RedoStack* instance_;
};

#endif
